﻿import math
def sigmoid(z,alfa):#■シグモイド関数
    zz=-z*alfa
    if zz>=100:return 0
    return 1.0/(1+math.exp(zz))
def compute(X,W):#■接続荷重の計算
    S=0
    for i in range(len(X)):S+=X[i]*W[i]
    return S
def gradMethod(rate, dEdy,X,W):#■接続荷重の変更
    DW=rate*dEdy
    for i in range(len(X)): W[i]-=DW*X[i]
    return W
def strW(W):#■接続荷重の文字列変換
    S="";PS=""
    for i in range(len(W)):
        S+=PS+"%9.3E" %W[i];PS=","
    return S
trX=[[1,1,1],[1,0,1],[0,1,1],[0,0,1]]#入力データ
trY=[[1,0,0,0]]                #出力教師データ(A AND  B)
#trY=[[1,1,1,0]]                #出力教師データ(A OR   B)
#trY=[[0,0,1,1]]                #出力教師データ(not A)
#trY=[[0,1,1,1]]                #出力教師データ(A NAND B)
#trY=[[1,1,1,0]]                #出力教師データ(A NAND B)
#trY=[[1,1,0,0]]                #出力教師データ(A)
#trY=[[1,0,1,0]]                #出力教師データ(B)
W=[0.5 for _ in range(len(trX[0]))]  #接続荷重初期値
alfa=5;rate=1;N=1000;er=0.00001       #実行パラメータ
prW=False;mode=0                      #実行オプション
for k in range(N):
    err=0
    for i in range(len(trX)):
        S=compute(trX[i],W)    #接続荷重の計算
        if mode==0:            #シグモイド関数適用
            Out=sigmoid(S,alfa)
            dEdy=(Out-trY[0][i])*(1-Out)*Out
        elif mode==1:          #tanh関数の適用その1
            Out=(1+math.tanh(S))*0.5
            dEdy=(Out-trY[0][i])*(1-Out*Out)
        elif mode==2:          #tanh関数の適用その2
            Out=math.tanh(S)
            dEdy=(Out-(2*trY[0][i]-1))*(1-Out*Out)
        W=gradMethod(rate,dEdy,trX[i],W)#接続荷重変更
        Dout=Out-trY[0][i]     #誤差
        err+=Dout*Dout
    if prW: print("%5d, %9.3E," % (k, err),strW(W))
    if err<er:break
print("結果 N=%d"%N)
print(" x1, x2, y, 計算結果")
for i in range(len(trX)):
    S=compute(trX[i],W)
    if mode==0: Out=sigmoid(S,alfa)
    else:Out=(1+math.tanh(S))*0.5
    if S>0:step=1
    else: step=0
    print("%2d, %2d, %2d, %8.4f,%2d" %
          (trX[i][0],trX[i][1],trY[0][i],Out,step))
          


        
        
        
